package com.tuoheng.common.core.utils;

import org.apache.commons.lang3.time.DateFormatUtils;

import java.lang.management.ManagementFactory;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/**
 * 时间工具类
 */
public final class DateUtils extends org.apache.commons.lang3.time.DateUtils {

    public static String YYYY = "yyyy";

    public static String YYYY_MM = "yyyy-MM";

    public static String YYYY_MM_DD = "yyyy-MM-dd";

    public static String YYYYMMDDHHMMSS = "yyyyMMddHHmmss";

    public static String YYYY_MM_DD_HH_MM_SS = "yyyy-MM-dd HH:mm:ss";

    public static String YYYY_MM_DD_HH_MM_SS_2 = "yyyy-MM-dd-HH-mm-ss";

    private static String[] parsePatterns = {
            "yyyy-MM-dd", "yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd HH:mm", "yyyy-MM",
            "yyyy/MM/dd", "yyyy/MM/dd HH:mm:ss", "yyyy/MM/dd HH:mm", "yyyy/MM",
            "yyyy.MM.dd", "yyyy.MM.dd HH:mm:ss", "yyyy.MM.dd HH:mm", "yyyy.MM"};


    /**
     * 获取当前时间
     *
     * @return
     */
    public static Date now() {
        return new Date();
    }

    /**
     * 获取当前日期, 默认格式为yyyy-MM-dd
     *
     * @return String
     */
    public static String getDate() {
        return dateTimeNow(YYYY_MM_DD);
    }

    public static final String getTime() {
        return dateTimeNow(YYYY_MM_DD_HH_MM_SS);
    }

    public static final String dateTimeNow() {
        return dateTimeNow(YYYYMMDDHHMMSS);
    }

    public static final String dateTimeNow(final String format) {
        return parseDateToStr(format, new Date());
    }

    public static final String dateTime(final Date date) {
        return parseDateToStr(YYYY_MM_DD, date);
    }

    public static final String parseDateToStr(final String format, final Date date) {
        return new SimpleDateFormat(format).format(date);
    }

    public static final Date dateTime(final String format, final String ts) {
        try {
            return new SimpleDateFormat(format).parse(ts);
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    /**
     * 检查字符串是否使时间格式
     *
     * @param format 格式
     * @param ts     时间字符串
     * @return 布尔值
     */
    public static boolean checkStrIsDate(final String format, final String ts) {
        try {
            new SimpleDateFormat(format).parse(ts);
            return true;
        } catch (ParseException e) {
            return false;
        }
    }

    /**
     * 日期路径 即年/月/日 如2018/08/08
     */
    public static final String datePath() {
        Date now = new Date();
        return DateFormatUtils.format(now, "yyyy/MM/dd");
    }

    /**
     * 日期路径 即年/月/日 如20180808
     */
    public static final String dateTime() {
        Date now = new Date();
        return DateFormatUtils.format(now, "yyyyMMdd");
    }

    /**
     * 日期型字符串转化为日期 格式
     */
    public static Date parseDate(Object str) {
        if (str == null) {
            return null;
        }
        try {
            return parseDate(str.toString(), parsePatterns);
        } catch (ParseException e) {
            return null;
        }
    }

    /**
     * 获取服务器启动时间
     */
    public static Date getServerStartDate() {
        long time = ManagementFactory.getRuntimeMXBean().getStartTime();
        return new Date(time);
    }

    /**
     * 计算两个时间差
     */
    public static String getDatePoor(Date endDate, Date nowDate) {
        long nd = 1000 * 24 * 60 * 60;
        long nh = 1000 * 60 * 60;
        long nm = 1000 * 60;
        // long ns = 1000;
        // 获得两个时间的毫秒时间差异
        long diff = endDate.getTime() - nowDate.getTime();
        // 计算差多少天
        long day = diff / nd;
        // 计算差多少小时
        long hour = diff % nd / nh;
        // 计算差多少分钟
        long min = diff % nd % nh / nm;
        // 计算差多少秒//输出结果
        // long sec = diff % nd % nh % nm / ns;
        return day + "天" + hour + "小时" + min + "分钟";
    }

    /**
     * 根据时间生成code
     */
    public static String generateCode(String prefix) {
        // 根据当前时间，生成任务编码
        Date date = new Date();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMddHHmmss");
        return prefix + formatter.format(date);
    }

    /**
     * 生成图片编号，P+年月日时分秒+随机三位数
     *
     * @return
     */
    public static String generateFileCode() {
        String Date = DateUtils.dateTimeNow(DateUtils.YYYYMMDDHHMMSS);
        int randomNum = (int) (Math.random() * 900) + 100;
        String fileCode = "P" + Date + randomNum;

        return fileCode;
    }

    /**
     * 返回字符串
     * <p>
     * 给原本的时间originDate加上自定义的时间
     *
     * @param originDate 原本的时间
     * @param day        要加的天数
     * @param hour       要加的小时数
     * @param minute     要加的分钟数
     * @param second     要加的秒数
     * @return 返回加完时间后的时间str_goalDate
     */
    public static String addDateTimeToStr(Date originDate, int day, int hour, int minute, int second) {
        SimpleDateFormat dateFormate = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Calendar cal = Calendar.getInstance();
        cal.setTime(originDate);
        cal.add(Calendar.DATE, day);// 24小时制,加天
        cal.add(Calendar.HOUR, hour);// 24小时制 ,加小时
        cal.add(Calendar.MINUTE, minute);// 24小时制,加分钟
        cal.add(Calendar.SECOND, second);// 24小时制,加秒

        String str_goalDate = dateFormate.format(cal.getTime());
        return str_goalDate;
    }

    /**
     * 返回java.util.Date
     * <p>
     * 给原本的时间originDate加上自定义的时间
     *
     * @param originDate 原本的时间
     * @param day        要加的天数
     * @param hour       要加的小时数
     * @param minute     要加的分钟数
     * @param second     要加的秒数
     * @return 返回加完时间后的时间goalDate
     */
    public static Date addDateTimeToDate(Date originDate, int day, int hour, int minute, int second) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(originDate);
        cal.add(Calendar.DATE, day);// 24小时制,加天
        cal.add(Calendar.HOUR, hour);// 24小时制 ,加小时
        cal.add(Calendar.MINUTE, minute);// 24小时制,加分钟
        cal.add(Calendar.SECOND, second);// 24小时制,加秒

        Date goalDate = cal.getTime();
        return goalDate;
    }

    /**
     * 比较2个时间
     *
     * @param date1
     * @param date2
     * @return -1：时间格式不对
     * 0：date1 == date2
     * 1：date1 < date2
     * 2：date1 > date2
     */
    public static int compareToDate(Date date1, Date date2) {
        String dateStr1 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(date1);
        String dateStr2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(date2);
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Calendar c1 = Calendar.getInstance();
        Calendar c2 = Calendar.getInstance();
        try {
            c1.setTime(df.parse(dateStr1));
            c2.setTime(df.parse(dateStr2));
        } catch (java.text.ParseException e) {
            System.err.println("格式不正确");
            return -1;
        }
        int result = c1.compareTo(c2);
        if (result == 0) {
            return 0;
        } else if (result < 0) {
            return 1;
        } else {
            return 2;
        }
    }

    public static String convert(String beforeFormat, String convertFormat, String dateString)  {
        if (StringUtils.isEmpty(dateString)) {
            return "";
        }
        SimpleDateFormat format = new SimpleDateFormat(beforeFormat);
        try {
            Date date = format.parse(dateString);
            SimpleDateFormat format2 = new SimpleDateFormat(convertFormat);
            return format2.format(date);
        } catch (ParseException e) {
            e.printStackTrace();
            return "";
        }
    }

    public static void main(String[] args) {
        // 当前时间
        Date date = new Date(System.currentTimeMillis());
        System.out.println("当前时间 = " + date);

        // 想加2小时5分10秒,且返回字符串
        String strDate = addDateTimeToStr(date, 0, 2, 5, 10);
        System.out.println("转换后的时间 = " + strDate);

        System.out.println("-------------");
        System.out.println("当前时间=" + date);
        // 想加3小时2分5秒,且返回Date
        Date goalDate = addDateTimeToDate(date, 0, 3, 2, 5);
        System.out.println("转换后的时间 = " + goalDate);
    }

}
